#!/usr/bin/perl

# ---------------------------------------------------------
#   "Rsync Here" v0.01
# ---------------------------------------------------------

use strict;
use warnings;

# get / validate arguments
  my $sourcePath_arg = shift;
  if (!$sourcePath_arg) {
    print "no source path given, exit.", "\n";
    exit;
  }

# config
  my $bash = "bash";
  my $rsync = "rsync";
  my $remote_ssh_prefix = 'joko@martha';
  my $remote_target_base = '~/backup';

# main - convert source path
  my $sourcePath_win32 = $sourcePath_arg;
  my $sourcePath = $sourcePath_win32;
  $sourcePath =~ s/^(\w)://i;
  my $sourcePath_volume = $1;
  $sourcePath =~ s/\\/\//g;
  #$sourcePath = "/cygdrive/$sourcePath_volume$sourcePath";
  
  # strip leading and trailing slash, if any
  $sourcePath =~ s/^\///;
  $sourcePath =~ s/\/$//;
  
  # make parts from path
  #my @path = split(/\//, $sourcePath);
  #my $sourcePath_rel = pop @path;
  #my $sourcePath_base = join("/", @path);
  
  #$sourcePath .= "/" if ($sourcePath !~ /\/$/);

# main - guess/build destination path
  my $hostname = lc $ENV{COMPUTERNAME};
  my $volume = lc $sourcePath_volume;
  $hostname ||= "DUMMY";
  $volume ||= "xx";
  my $target_remote = "$remote_ssh_prefix:$remote_target_base/$hostname/$volume/";

# main - build rsync command
  my $cmd;
  $cmd = "$bash -c 'cd /cygdrive/$sourcePath_volume; $rsync -R -azuv -e ssh --progress \"$sourcePath\" \"$target_remote\"'";
  print "synchronizing directories with...", "\n";
  print "cmd: ", $cmd, "\n";

# main - run rsync
  print `$cmd`;
  
  print "\n";
  print "sleeping for 1 minute...";
  `sleep 1m`;
  